datablock AudioProfile(torchHitSound)
{
   filename    = "./torchHit.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock ExplosionData(torchExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = torchHitSound;

   particleEmitter = AdminWandExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "1 0.65 0";
   lightEndColor = "0 0 0";
};
AddDamageType("Torch",   '<bitmap:add-ons/Item_Torch/CI_Torch> %1',    '%2 <bitmap:add-ons/Item_Torch/CI_Torch> %1',0.75,1);
datablock ProjectileData(torchProjectile)
{
   directDamage        = 5;
   directDamageType  = $DamageType::Torch;
   radiusDamageType  = $DamageType::Torch;
   explosion           = torchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Torch Hit";
};

//////////
// item //
//////////
datablock ItemData(TorchJItem)
{
	category = "Item";  // Mission editor category

	equipment = true;

	//its already a member of item namespace so dont break it
	//className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Torch.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Torch";
	iconName = "./Torch";
	
	 // Dynamic properties defined by the scripts
	image = TorchJWeaponImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TorchjWeaponImage)
{
   // Basic Item properties
   shapeFile = "./Torch.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0 0 0";

   doColorShift = false;
   lightType = "ConstantLight";
   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 0.65 0";
   

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TorchJItem;
   ammo = " ";
   projectile = torchProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   doColorShift = false;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateEmitter[0]					= AdminWandEmitterB;
	stateEmitterTime[0]				= 10000;
        stateSound[0] = torchHitSound;
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateEmitter[1]					= AdminWandEmitterA;
	stateEmitterTime[1]				= 10000;
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateEmitter[2]					= AdminWandEmitterA;
	stateEmitterTime[2]				= 10000;
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateEmitter[3]					= AdminWandEmitterA;
	stateEmitterTime[3]				= 10000;
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateEmitter[4]					= AdminWandEmitterA;
	stateEmitterTime[4]				= 10000;
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateEmitter[5]					= AdminWandEmitterA;
	stateEmitterTime[5]				= 10000;
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

function TorchjWeaponImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function TorchjWeaponImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function torchProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %client)
{
   if(isObject(%col) || (%col.getclassname() $= "Player" && %col.getclassname() $= "AIPlayer"))
    {
	%mini = getMinigameFromObject(%client) && getMinigamefromObject(%col);
	if(!isObject(%mini))
	{
		return;
	}
        else
	{        
           cancel(%col.torchFireBurn);
	   %col.torchFireBurn(50,85,0,1);
	}
    }
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %client);
}

function Player::torchFireBurn(%this, %dps, %max, %num, %burnFX)
{
        if(!isObject(%this))   
         return;
   if(%num <= %max)
   {
      %this.applyDamage((%dps/10));
            %this.torchFireBurn = %this.schedule(100, torchFireBurn, %max, %num + (%dps/10), 0);
             if(%burnFX){%this.burn(%num*100);}
   }
}

